var version = 152;
var bottom = 0;
var top = 5;
var show = 0;
var max = 0;
var launched = 0;
var clicked = 0;
var flipShown = false; 
var timeset = 0;
var progress = 0;
var elementHeight = 31;
var elementHeightFav = 18.3;
var pTimer = null;
var wentOver = false;
var downloadHours = 4;
var favorites = false;
var numberOfChannels = 0;
var needsRefresh = false;
var numberOfFavorites = 0;
var imgPL = new Array();
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0,  firstElement:null, timer:null}; 
var canScrollUp;
var canScrollDown;
var updateTimer = null;
var minute = 0;
var goBackToZero = false;
var showingBack = false;
var showingFront = true;

if(window.widget) {
   widget.onshow = onshow;
   widget.onhide = onhide;
}


function onshow () {
    if (launched==0) {
        //setup();
        launched += 1;
    }
    if (updateTimer != null) {
        clearInterval(updateTimer);
        updateTimer = null;
    }
    minute = 0;
}

function onhide () {
    var autoup = widget.preferenceForKey("autoUpdate");
    var dateNow = new Date();
    minute = dateNow.getMinutes();
    
    if (updateTimer == null && parseInt(autoup)==1 ) {
        updateTimer = setInterval("updateRefreshTimer();", 60000);
    }
    //nextAndPrevious();
}

function updateRefreshTimer() {
    if (goBackToZero) {
        minute = 0;
        goBackToZero = false;
    } else {
        minute++;
    }
    if (minute == 30) {
        if (showingBack) {
            showFront();
        }
        goBackToOrigin();
    } else if (minute == 59) {
        goBackToZero = true;
    } else if (minute == 0) {
        if (showingBack) {
            showFront();
        }
        goBackToOrigin();
    }
}

function readIn(filename) {
    req = new XMLHttpRequest();
    req.open("GET", filename ,false);
    req.send(null);
    response = req.responseText;
    if (response) {
        return response;
    } else {
        return "";
    }
}

function maxChannels() {
    var sys_max = widget.system("/usr/bin/python main.py --max", null)
    var out = sys_max.outputString;
    if (out=="" || out==null) {
        max = 0;
    } else {
        max = out;
    }
}

function writeToContainer(s) {
    document.getElementById("container").innerHTML = s;
}

function appendToContainer(s) {
    var prev = document.getElementById("container").innerHTML;
    document.getElementById("container").innerHTML = prev + s;
}

function printListing() {
    var pchan = widget.system("/usr/bin/python main.py --printlisting "+bottom+" "+max+" "+show,null);
    var channels = pchan.outputString;
    
    if(top>=max) {
        showOnly = max-bottom;
    } else {
        showOnly = 5;
    }
    
    if (channels) {
    	document.getElementById("notice").innerHTML = " ";
        document.getElementById("timers").innerHTML = channels;
    } else {
        document.getElementById("notice").innerHTML = "<span onClick='showBack();'>Click here<br>to configure<br>TV Tracker.</span>";
        document.getElementById("timers").innerHTML = " ";
    }
    writeToContainer(readIn("channel.html"));
    appendToContainer(readIn("channel_head.html"));
}

function setup() {
    var hours = widget.preferenceForKey("downloadHours");
    var zip = widget.preferenceForKey("zip");
    var autoup = widget.preferenceForKey("autoUpdate");
    
    if (zip) {
        document.getElementById('zipper').value = zip;
        processZip(zip);
    }
    if(hours) {
        downloadHours = parseInt(hours);
    } else {
        downloadHours = 4;
    }
    
    if(parseInt(autoup)==1) {
        document.getElementById('yes').selected = true;
    } else {
        document.getElementById('no').selected = true;
    }
    var up = widget.system("/usr/bin/python upgrade.py",null).outputString
    if (up) {
        if (parseInt(up)!=version) {
            attachUpgradeButton();
        }
    }
    preLoadImages();
    selectHour();
    document.getElementById('front').style.display = "block";
	document.getElementById('back').style.display = "none";
	createGenericButton (doneit, "Done", showFront);
	createGenericButton (all, "Select All", selectAll);
	createGenericButton (helper, "?", showHelp);
	writeToContainer("");
    document.getElementById("timers").innerHTML = "";
    needsRefresh = false;
    test();
    
}

function preLoadImages() {
    imgPL[0] = new Image();
    imgPL[0].src = "Images/DownloadingData.png";
    imgPL[1] = new Image();
    imgPL[1].src = "Images/Back.png";
    imgPL[2] = new Image();
    imgPL[2] = "RealDefault.png";
    imgPL[3] = new Image();
    imgPL[3] = "Images/PressedButtonState_03.png";
    imgPL[4] = new Image();
    imgPL[4] = "Images/PressedButtonState_02.png";
    imgPL[5] = new Image();
    imgPL[5] = "Images/PressedButtonState_01.png";
}
function selectHour() {
    switch(downloadHours) {
        case 2:
            document.getElementById("two").selected = true;
            break;
        case 4:
            document.getElementById("four").selected = true;
            break;
        case 6:
            document.getElementById("six").selected = true;
            break;
        case 8:
            document.getElementById("eight").selected = true;
            break;
    }
}
function attachUpgradeButton() {
    logo = document.getElementById("logo");
    glow = document.getElementById("logo_glow");
    logo.style.background = "url(Images/download.png)";
    glow.style.background = "url(Images/download_roll.png)";
    glow.style.left = "0px";
    glow.style.top = "0px";
    glow.style.width= "138px";
    glow.style.height= "131px";
}
function callError(text) {
    document.getElementById('error').innerHTML = text;
}
function test() {
    writeToContainer("");
    document.getElementById("timers").innerHTML = "";
    progressShow();
    widget.system("/bin/rm -rf ./channel_head.html ./channel.html ./listings*.pk",null);
    var out = widget.system("/usr/bin/python main.py --getlisting "+downloadHours+" "+timeset, null).outputString;
    if (out==-1) {
        document.getElementById("loader").innerHTML = "";
        needsRefresh = true;
        showBack();
        callError("Network Connection Error.");
        return -1;
    }
    maxChannels();
    progressHide();
    nextAndPreviousHour();
    printListing();
    setScroller(1)
    if(max > 4) {
        canScrollDown = true;
        canScrollUp = false;
    }
    setHeight(elementHeight*max);
    calculateAndShowThumb(document.getElementById("container"));
    scrollContent(-1);
}

function zipper(zip) {
    var canada = new RegExp("[A-Za-z]")
    if(zip.length==5) {
        var firstchar = zip.charAt(0)
        if(!firstchar.match(canada)) {
            widget.system("/usr/bin/python main.py --country 0",null);
            processZip(zip);
        }
    } else if (zip.length==6 && zip.charAt(0).match(canada)) {
        widget.system("/usr/bin/python main.py --country 1",null);
        processZip(zip);
    }
}

function hours(hour) {
    var num = new RegExp("^[0-9]*$");
    if(window.widget) {
        widget.setPreferenceForKey(parseInt(hour), "downloadHours");
        downloadHours = parseInt(hour);
        needsRefresh = true;
        show=0;
        timeset=0;
    }
}

function autoUpdate(update) {
    if(window.widget) {
        widget.setPreferenceForKey(parseInt(update), "autoUpdate");
    }
}

function reloadFavorites() {
    var sys_get = widget.system("/usr/bin/python main.py --getlisting 1 0",null);
    if (sys_get.outputString == -1) {
        callError("Network connection error.");
        return -1;
    }
    createFavoritesList();
    document.getElementById("favorites").innerHTML = readIn("channel_list.html");
    setHeight(elementHeightFav*numberOfChannels);
    setScroller(2);
    calculateAndShowThumb(document.getElementById("favorites"));
    scrollContent(-1);
}
function lineup(line) {
    var myline = line.value;
    if (myline!="") {
        //widget.setPreferenceForKey(myline,makeKey("lineup"));
        document.getElementById("loader2").innerHTML = '<img src="Images/download.gif" width="23" height="5">';
        var sys_setlineup = widget.system("/usr/bin/python main.py --setlineup "+myline, null);
        needsRefresh = true;
        reloadFavorites();
        document.getElementById("loader2").innerHTML = '';
        //document.getElementById("all").innerHTML = "";
        updateSelectors();
    }
}

function setLoad() {
    document.getElementById("load").innerHTML = '<img src="nav/load.png" value="Load" onClick="runLoad();">'
}

function runLoad() {
    showFront();
    test();
}
function processZip(zip) {
    widget.setPreferenceForKey(zip,"zip");
    document.getElementById("loader2").innerHTML = '<img src="Images/download.gif" width="23" height="5">';
    var sys_lineup= widget.system("/usr/bin/python main.py --getlineup "+zip, null);
    var lineup = readIn("providers.html");
    if(!lineup || sys_lineup.outputString == -1) {
        document.getElementById("loader2").innerHTML = '';
        callError("Network connection error.");
        return -1;
    }
    if(lineup) {
        document.getElementById("provider").innerHTML = lineup;
        needsRefresh = true;
    }
    document.getElementById("loader2").innerHTML = '';
}

function nextAndPreviousHour() {
    
    if(show == 0) {
        document.getElementById("timeNav").innerHTML = ''+
    '<div id="rightarrow" style="position:absolute; left:161px; top:222px; width:48px; height:45px; z-index:5;border:none;" onMouseDown="stateChangeDown(event,this,\'03\',1);"><img id="ra" src="Images/RegularButtonState_03.png"  width="47" height="38" style="padding:0px 0px 0px 0px;"></div>'+
    '<div id="midarrow" style="position:absolute; left:137px; top:222px; width:24px; height:38px; z-index:4;border:none;" onMouseDown="stateChangeDown(event,this,\'02\',5);"><img id="ma" src="Images/RegularButtonState_02.png" border=0  width="24" height="38"></div>'+
    '<div id="leftarrow" style="position:absolute; left:90px; top:222px; width:47px; height:38px; z-index:3;border:none;" onMouseDown="stateChangeDown(event,this,\'01\',4);"><img id="la" src="Images/RegularButtonState_01.png" border=0  width="47" height="38"  style="border:none"></div>';
    } else if (show==(downloadHours-1)) {
        document.getElementById("timeNav").innerHTML = ''+
   '<div id="rightarrow" style="position:absolute; left:161px; top:222px; width:47px; height:38px; z-index:5;border:none;" onMouseDown="stateChangeDown(event,this,\'03\',3);"><img id="ra" src="Images/RegularButtonState_03.png" border="0"  width="47" height="38" style="border:none"></div>'+
   '<div id="midarrow" style="position:absolute; left:137px; top:222px; width:24px; height:38px; z-index:4" onMouseDown="stateChangeDown(event,this,\'02\',5);"><img id="ma" border="0" src="Images/RegularButtonState_02.png" width="24" height="38" style="border:none"></div>'+
   '<div id="leftarrow" style="position:absolute; left:90px; top:222px; width:47px; height:38px; z-index:3" onMouseDown="stateChangeDown(event,this,\'01\',2);"><img id="la" border="0" src="Images/RegularButtonState_01.png" width="47" height="38" style="border:none"></div>';
    } else {
        document.getElementById("timeNav").innerHTML = ''+
    '<div id="rightarrow" style="position:absolute; left:161px; top:222px; width:47px; height:38px; z-index:5;border:none;" onMouseDown="stateChangeDown(event,this,\'03\',1);"><img id="ra" src="Images/RegularButtonState_03.png" border="0" width="47" height="38"></div>'+
    '<div id="midarrow" style="position:absolute; left:137px; top:222px; width:24px; height:38px; z-index:4" onMouseDown="stateChangeDown(event,this,\'02\',5);"><img id="ma" border="0" src="Images/RegularButtonState_02.png" width="24" height="38" style="border:none"></div>'+
    '<div id="leftarrow" style="position:absolute; left:90px; top:222px; width:47px; height:38px; z-index:3" onMouseDown="stateChangeDown(event,this,\'01\',2);"><img id="la"  border="0" src="Images/RegularButtonState_01.png"width="47" height="38"></div>'; 
    }
}

var imRoll = null;
function stateChangeDown(event,im,num,which) {
    im.childNodes[0].src = "Images/PressedButtonState_"+num+".png";
    switch(which) {
        case 1:
            document.addEventListener("mousemove", stateMoveHandler, true);
            document.addEventListener("mouseup", nextHourHandler, true);
            break;
        case 2:
            document.addEventListener("mousemove", stateMoveHandler, true);
            document.addEventListener("mouseup", prevHourHandler, true);
            break;
        case 3:
            document.addEventListener("mousemove", stateMoveHandler, true);
            document.addEventListener("mouseup", nextTimeSetHandler, true);
            break;
        case 4:
            document.addEventListener("mousemove", stateMoveHandler, true);
            document.addEventListener("mouseup", prevTimeSetHandler, true);
            break;
        case 5:
            document.addEventListener("mousemove", stateMoveHandler, true);
            document.addEventListener("mouseup", originHandler, true);
            break;
    }
    imRoll = im;
	event.stopPropagation();
	event.preventDefault();
}

function stateMoveHandler(event) {
    event.stopPropagation();
	event.preventDefault();
	
}

function nextHourHandler(event) {
    imRoll.childNodes[0].src = "Images/RegularButtonState_03.png";
    document.removeEventListener("mousemove", stateMoveHandler, true);
    document.removeEventListener("mouseup", nextHourHandler, true);
    nextHour();
}

function prevHourHandler(event) {
    imRoll.childNodes[0].src = "Images/RegularButtonState_01.png";
    document.removeEventListener("mousemove", stateMoveHandler, true);
	document.removeEventListener("mouseup", prevHourHandler, true);
	prevHour();
}

function nextTimeSetHandler(event) {
    imRoll.childNodes[0].src = "Images/RegularButtonState_03.png";
    document.removeEventListener("mousemove", stateMoveHandler, true);
	document.removeEventListener("mouseup", nextTimeSetHandler, true);
	nextTimeSet();
}

function prevTimeSetHandler(event) {
    imRoll.childNodes[0].src = "Images/RegularButtonState_01.png";
    document.removeEventListener("mousemove", stateMoveHandler, true);
	document.removeEventListener("mouseup", prevTimeSetHandler, true);
	event.stopPropagation();
	event.preventDefault();
	prevTimeSet();
}

function originHandler(event) {
    imRoll.childNodes[0].src = "Images/RegularButtonState_02.png";
    document.removeEventListener("mousemove", stateMoveHandler, true);
	document.removeEventListener("mouseup", originHandler, true);
	goBackToOrigin();
}
function stateChangeUp(event,im,num,which) {
    im.src = "Images/RegularButtonState_"+num+".png";
    switch(which) {
        case 1:
            nextHour();
            break;
        case 2:
            prevHour();
            break;
        case 3:
            nextTimeSet();
            break;
        case 4:
            prevTimeSet();
            break;
        case 5:
            goBackToOrigin();
            break;
    }
    event.stopPropagation();
	event.preventDefault();
}
function stateChangeOut(event,im,num) {
    im.src = "Images/RegularButtonState_"+num+".png";
    event.stopPropagation();
	event.preventDefault();
}
function prevTimeSet() {
    timeset--;
    show = downloadHours-1;
    test();
}
function nextTimeSet() {
    timeset++;
    show = 0;
    test();

}
function prevHour() {
    show -= 1;
    printListing();
    nextAndPreviousHour();
}

function nextHour() {
    show += 1;
    printListing();
    nextAndPreviousHour();
}

function nextAndPreviousChannel() {
    if(bottom == 0) {
        document.getElementById("channelNav").innerHTML = ''+
    '<div id="uparrow" style="position:absolute; left:23px; top:14px; width:79px; height:23px; z-index:5"> <img src="nav/uparrow_d.png"></div>'+
    '<div id="downarrow" style="position:absolute; left:24px; top:219px; width:78px; height:24px; z-index:6"><img src="nav/downarrow.png" width="75" height="18" onClick="nextChannel();"></div>';
    } else if (top>=max) {
        document.getElementById("channelNav").innerHTML = ''+
    '<div id="uparrow" style="position:absolute; left:23px; top:14px; width:79px; height:23px; z-index:5"> <img src="nav/uparrow.png" onClick="prevChannel()";></div>' +
    '<div id="downarrow" style="position:absolute; left:24px; top:219px; width:78px; height:24px; z-index:6"><img src="nav/downarrow_d.png" width="75" height="18"></div>';
    } else {
        document.getElementById("channelNav").innerHTML = ''+
    '<div id="uparrow" style="position:absolute; left:23px; top:14px; width:79px; height:23px; z-index:5"> <img src="nav/uparrow.png" onClick="prevChannel();"></div> '+
    '<div id="downarrow" style="position:absolute; left:24px; top:219px; width:78px; height:24px; z-index:6"><img src="nav/downarrow.png" width="75" height="18" onClick="nextChannel();"></div>';
    }
    
}
function createGoToURL(location) {
    return unescape(location);
}

function launch(url) {
    widget.openURL(createGoToURL(url));
}

function prevChannel() {
    top = bottom;
    bottom = bottom-5;
    printListing();
    nextAndPreviousChannel();
}
function dbg(t) {
    document.getElementById("debug").innerHTML = t
}
function nextChannel() {
    bottom = top;
    top = top+5;
    printListing();
    nextAndPreviousChannel();
}
function flipToChannel() {
    c = document.getElementById("channel");
    c.innerHTML = "<input id='fchan' type='text' size=4><input type='submit' value='Go' onClick='findChannel();'>";
}
function findChannel() {
    c = document.getElementById("fchan");
    val = c.value;
    if( val=="") {
        quickReload();
        return 0;
    }
    sys_find = widget.system("/usr/bin/python main.py --find "+val,null);
    out = sys_find.outputString;
    out = parseInt(out);
    if(out==-1) {
        quickReload();
        return 0;
    }
    bottom = parseInt(out);
    top = parseInt(out)+1;
    var sys_print = widget.system("/usr/bin/python main.py --printlisting " + bottom +" " + top, null);
    var list = sys_print.outputString;
    document.getElementById("container").innerHTML = list;
    nextAndPrevious();
}
function quickReload() {
    var sys_print = widget.system("/usr/bin/python main.py --printlisting "+bottom+" "+top, null);
    var list;
    list = sys_print.outputString;
    document.getElementById("container").innerHTML = list;
    nextAndPrevious();
}
function refresh() {
    var sys_listing = widget.system("/usr/bin/python main.py --getlisting", null);
    var total = sys_listing.outputString;
    max = total;
    var sys_print = widget.system("/usr/bin/python main.py --printlisting "+bottom+" "+top, null);
    var list;
    list = sys_print.outputString;
    document.getElementById("container").innerHTML = list;
    nextAndPrevious();
}
function goBackToOrigin() {
    show = 0;
    timeset = 0;
    test();
}




function mousemove(event) {     
	if (!flipShown) {         
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;         
		}  
       
		var starttime = (new Date).getTime() - 13; 

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	} 
} 

function mouseexit (event) {     
	if (flipShown) {
		// fade in the flip widget
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}

		var starttime = (new Date).getTime() - 13;
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	} 
} 

function animate() {     
	var T;
	var ease;
	var time = (new Date).getTime(); 

	T = limit_3(time-animation.starttime, 0, animation.duration);
	if (T >= animation.duration) {
		clearInterval(animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat(animation.from, animation.to, ease);
	}     
	
	animation.firstElement.style.opacity = animation.now; 
} 

function limit_3 (a, b, c) {
	return a < b ? b : (a > c ? c : a); 
} 

function computeNextFloat (from, to, ease) {
	return from + (to - from) * ease; 
}

function progressShow() {
    document.body.background = "Images/DownloadingData.png";
    document.getElementById("myScrollThumb1").style.display = "none";
    document.getElementById("flip").style.display = "none";
    document.getElementById("loader").innerHTML = '<img src="Images/download.gif" width="23" height="5">';
}

function progressHide() {
    document.getElementById("flip").style.display = "block";
    document.body.background = "RealDefault.png";
    document.getElementById("loader").innerHTML = "";
}

function turnOnGlow() {
    document.getElementById("logo_glow").style.display = "block"
}

function turnOffGlow() {
    document.getElementById("logo_glow").style.display = "none"

}
function updateProgress() {
    if (progress==20)
        progress = 0
    document.getElementById("loader").src = "nav/loader/load"+progress+".png";
    document.getElementById("loader").style.display = "block";
    progress++;
}


function createFavoritesList() {
    var sys_chan = widget.system("/usr/bin/python main.py --createfav",null);
    var sys_maxchan = widget.system("/usr/bin/python main.py --maxchannels",null);
    numberOfChannels = sys_maxchan.outputString;
    numberOfFavorites = parseInt(sys_chan.outputString);
    updateSelectors();
}

function setFavorite(element) {
    needsRefresh = true;
    var name = element.name;
    var value = element.value;
    var sys_fav = widget.system("/usr/bin/python main.py --setfav "+value+" "+name,null);
    numberOfFavorites = parseInt(sys_fav.outputString);
    updateSelectors();
}

function updateSelectors() {
    var oldButtonText = new String(document.getElementById("all").childNodes[1].innerHTML);
    if (numberOfFavorites==0) {
        if ( oldButtonText.indexOf( "Select All") == -1 ) {
            document.getElementById("all").innerHTML = "";
            createGenericButton(all,"Select All",selectAll);
        }
    } else {
        if( oldButtonText.indexOf( "Unselect All") == -1 ) {
            document.getElementById("all").innerHTML = "";
            createGenericButton(all,"Unselect All",unSelectAll);
        }
    }
}
function selectAll() {
    var sys_clear = widget.system("/usr/bin/python main.py --clearfav",null);
    var sys_chan = widget.system("/usr/bin/python main.py --createallfav",null);
    var sys_maxchan = widget.system("/usr/bin/python main.py --maxchannels",null);
    document.getElementById("favorites").innerHTML = readIn("channel_list.html");
    numberOfFavorites = parseInt(sys_chan.outputString);
    needsRefresh = true;
    document.getElementById("all").innerHTML = "";
    createGenericButton(all,"Unselect All",unSelectAll);
}
function unSelectAll() {
    var sys_clear = widget.system("/usr/bin/python main.py --clearfav",null);
    var sys_chan = widget.system("/usr/bin/python main.py --createfav",null);
    var sys_maxchan = widget.system("/usr/bin/python main.py --maxchannels",null);
    document.getElementById("favorites").innerHTML = readIn("channel_list.html");
    needsRefresh = true;
    document.getElementById("all").innerHTML = "";
    createGenericButton(all,"Select All",selectAll);
}


function showBack() {     
	if (window.widget)         
		widget.prepareForTransition("ToBack");
    showingBack = true;
    showingFront = false;
    tracking = true;
    document.getElementById("notice").innerHTML = "";
	document.getElementById("front").style.display = "none";
	document.getElementById("error").innerHTML = "";     
	document.getElementById("back").style.display = "block";
	document.body.background = "Back.png";
	if(!favorites) {
        createFavoritesList();
        document.getElementById("favorites").innerHTML = readIn("channel_list.html");
        setScroller(2);
        //setHeight(elementHeightFav*numberOfChannels);
        calculateAndShowThumb(document.getElementById("favorites"));
        scrollContent(-1)
        favorites = true;
	} else {
	   updateSelectors();
	   setScroller(2);
	   setHeight(elementHeightFav*numberOfChannels);
       calculateAndShowThumb(document.getElementById("favorites"));
       scrollContent(-1)
	}
    
	if (window.widget)         
		setTimeout ('widget.performTransition();', 0);   
	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
}  
function doFront() {
    showFront();
}
function showHelp() {
    widget.openURL("http://www.monkeybusinesslabs.com/tvtracker/support.html");
}
function showFront() {     

	if (window.widget)         
		widget.prepareForTransition("ToFront");     
    showingFront = true;
    showingBack = false;
	document.getElementById("back").style.display = "none";
	document.getElementById("error").innerHTML = "";     
	document.getElementById("front").style.display = "block";
	document.body.background = "RealDefault.png";
	setHeight(elementHeight*max);
    setScroller(1);
    calculateAndShowThumb(document.getElementById("container"));
    scrollContent(-1);
    
	if (window.widget)         
		setTimeout ('widget.performTransition();', 0);
	
    if(needsRefresh) {
        needsRefresh = false;
        test();
    }
    
}
function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}
function makeKey(key)
{
	return widget.identifier + "-" + key;
}

// SCROLL STUFF

function mouseWheelScrolled(event) {
    var tickCount = event.wheelDelta / 120.0;
    
    if (event.wheelDelta > 0)
    {
        while (tickCount-- > 0)
        {
            scrollUp();
        }
    }
    else if (event.wheelDelta < 0)
    {
        while (tickCount++ < 0)
        {
            scrollDown();
        }
    }
    mouseStillDown = false;
}
function scrollUp()
{
    
    scrollUpWheel();
    //scrollContent(currentContentTop+20);
    //if (mouseStillDown) {
    //    setTimeout("scrollUp();", scrollSpeed)        
    //}
}

function scrollDown()
{    
    scrollDownWheel();
    //scrollContent(currentContentTop-20);
    //if (mouseStillDown) {
    //    setTimeout("scrollDown();", scrollSpeed)
    //} 
}

function keyPressed (event)
{
    
    var handled = false;
    
    
    if(showingFront) {
        setScrollWheelSpeed(31);
    }else {
        setScrollWheelSpeed(18);
    }
    //up
    if (event.keyCode == 38 || event.keyCode == 63232) // up arrow
    {
        document.getElementById("zipper").blur();
        scrollUp();
        handled = true;
    //down
    } else if ( event.keyCode == 40 || event.keyCode == 63233) {
        document.getElementById("zipper").blur();
        scrollDown();
        handled = true;
    //pageup
    } else if ( event.keyCode == 63276 || event.keyCode == 33 ) {
        document.getElementById("zipper").blur();
        tracking = true;
        pageUp();
        handled = true;
    //pagedown
    } else if ( event.keyCode == 63277 || event.keyCode == 34 ) {
        document.getElementById("zipper").blur();
        tracking = true;
        pageDown();
        handled = true;
    }

    if (handled) {
        event.stopPropagation();
        event.preventDefault();
    }
}

document.addEventListener("keypress", keyPressed, true);
document.addEventListener("mousewheel", mouseWheelScrolled, true);